Subject: Re: bug#38748: 28.0.50; crash on MacOS 10.15.2

From: Pip Cet <[email-masked]>
Date: Wed, 8 Jan 2020 20:39:43 +0000

On Wed, Jan 8, 2020 at 7:58 PM Eli Zaretskii <[email-masked]> wrote:
> > > Yes. Iʼll note that when this happens there are over 9000 stackframes,
> > > so perhaps itʼs stack exhaustion. macOS has a default stack of 8192
> > > kB, Iʼll see if increasing it helps.
> > That does sound like infinite recursion, or infinite recursion waiting
> > for something to change asynchronously that breaks the loop.
> No, GC is known to take many thousands of recursive calls to
> mark_object.  9000 is not a particularly high number, and doesn't
> necessarily signal infinite recursion.

In general, you're absolutely correct. But in this case, it still
sounds very likely: infinite recursion of a properly tail-recursive
function would loop rather than cause a stack overflow, which would
explain everything, except for why it's not actually an infinite loop;
I suspect the macOS code somewhere does modify things asynchronously.